image: docker:stable

variables:
  DEFAULT_IMAGE: docker:stable
  DIND_IMAGE: docker:stable-dind
  GIT_SUBMODULE_STRATEGY: recursive
  GITLAB_CONTAINER_IMAGE: $CI_REGISTRY/$CI_PROJECT_PATH
  PROJECT_DIR: $CI_PROJECT_DIR
  HOME: /root
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  APP: $APP_DEPLOY_FROM_ENV

stages:      
  - init
  - test
  - build

init:
  stage: init
  services:
    - $DIND_IMAGE
  script:
    - docker info
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build --rm --cache-from ${GITLAB_CONTAINER_IMAGE}:latest -t ${GITLAB_CONTAINER_IMAGE}:${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHA} -t ${GITLAB_CONTAINER_IMAGE} .
    - docker push ${GITLAB_CONTAINER_IMAGE}:${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHA}
    - docker push ${GITLAB_CONTAINER_IMAGE}:latest
    - rm -f /root/.docker/config.json
  when: manual

code_quality:
  stage: test
  services:
    - $DIND_IMAGE
  script:
    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
    - code_quality
  allow_failure: true
  only:
    - branches
  except:
    - develop
  artifacts:
    paths: [gl-code-quality-report.json]

license_management:
  stage: test
  image: 
    name: "registry.gitlab.com/gitlab-org/security-products/license-management:$CI_SERVER_VERSION_MAJOR-$CI_SERVER_VERSION_MINOR-stable"
    entrypoint: [""]
  allow_failure: true
  script:
    - license_management
  artifacts:
    paths: [gl-license-management-report.json]
  only:
    refs:
      - branches
    variables:
      - $GITLAB_FEATURES =~ /\blicense_management\b/
  except:
    variables:
      - $LICENSE_MANAGEMENT_DISABLED

sast:
  stage: test
  allow_failure: true
  services:
    - $DIND_IMAGE
  image: docker:stable
  script:
    - setup_docker
    - sast
  artifacts:
    paths: [gl-sast-report.json]
  only:
    refs:
      - branches
    variables:
      - $GITLAB_FEATURES =~ /\bsast\b/
  except:
    variables:
      - $SAST_DISABLED

dependency_scanning:
  stage: test
  image: docker:stable
  allow_failure: true
  services:
    - $DIND_IMAGE
  script:
    - setup_docker
    - dependency_scanning
  artifacts:
    paths: [gl-dependency-scanning-report.json]
  only:
    refs:
      - branches
    variables:
      - $GITLAB_FEATURES =~ /\bdependency_scanning\b/
  except:
    variables:
      - $DEPENDENCY_SCANNING_DISABLED

container_scanning:
  stage: test
  image: docker:stable
  allow_failure: true
  services:
    - $DIND_IMAGE
  script:
    - setup_docker
    - container_scanning
  artifacts:
    paths: [gl-container-scanning-report.json]
  only:
    refs:
      - branches
    variables:
      - $GITLAB_FEATURES =~ /\bcontainer_scanning\b/
  except:
    variables:
      - $CONTAINER_SCANNING_DISABLED

dast:
  stage: test
  allow_failure: true
  image: registry.gitlab.com/gitlab-org/security-products/zaproxy
  variables:
    POSTGRES_DB: "false"
  script:
    - dast
  artifacts:
    paths: [gl-dast-report.json]
  only:
    refs:
      - branches
    kubernetes: active
    variables:
      - $GITLAB_FEATURES =~ /\bdast\b/
  except:
    refs:
      - master
    variables:
      - $DAST_DISABLED

build:
  stage: build
  image: $GITLAB_CONTAINER_IMAGE
  script:
     - cd $PROJECT_DIR/Turpial
     - make clean && make
  artifacts:
    expire_in: 1 week
    paths: [Turpial/build/Turpial.elf]
  dependencies:
    - init

.prepare_env: &prepare_env |
  function code_quality() {
    docker run --env SOURCE_CODE="$PWD" \
               --volume "$PWD":/code \
               --volume /var/run/docker.sock:/var/run/docker.sock \
               "registry.gitlab.com/gitlab-org/security-products/codequality:latest" /code
  }

before_script:
  - *prepare_env


